# WARNING : Version 3.3.4 or higher of FFTW is recommended (an older version can induced fatal bugs during execution)
IF (${NAMEHOST} MATCHES ${NAMEHOST_ZEUS})
	FIND_PATH(FFTW_INCLUDE_PATH
		NAMES fftw3.h
		PATHS /share/libraries/fftw/3.3.4/gcc/4.8.5/include
		NO_DEFAULT_PATH
	)

	FIND_LIBRARY(FFTW_LIBRARY
		NAMES libfftw3.a
		PATHS /share/libraries/fftw/3.3.4/gcc/4.8.5/lib
		NO_DEFAULT_PATH
	)
ELSE()
	FIND_PATH(FFTW_INCLUDE_PATH
		NAMES fftw3.h
		PATHS /usr/include
		NO_DEFAULT_PATH
		)

	FIND_LIBRARY(FFTW_LIBRARY
		NAMES fftw3
		PATHS /usr/lib/x86_64-linux-gnu
		NO_DEFAULT_PATH
		)
ENDIF()

IF(FFTW_LIBRARY)
	SET(FFTW_LIBRARIES ${FFTW_MPI_LIBRARY};${FFTW_LIBRARY})
ENDIF()

IF(FFTW_INCLUDE_PATH)
	MESSAGE(STATUS "Found FFTW3 header: ${FFTW_INCLUDE_PATH}/fftw3.h")
ELSE()
	MESSAGE(FATAL_ERROR "Could not find FFTW3 header")
ENDIF()

IF(FFTW_LIBRARY)
	MESSAGE(STATUS "Found FFTW3 library: ${FFTW_LIBRARY}")
ELSE()
	MESSAGE(FATAL_ERROR "Could not find FFTW3 library")
ENDIF()
