IF (${NAMEHOST} MATCHES ${NAMEHOST_ZEUS})
	FIND_PATH(HDF5_INCLUDE_PATH
		NAMES hdf5.h
		PATHS /share/libraries/hdf5/1.8.18/gcc/4.8.5/mpi/include
		NO_DEFAULT_PATH
	)

	FIND_LIBRARY(HDF5_LIBRARY
		NAMES libhdf5.a
		PATHS /share/libraries/hdf5/1.8.18/gcc/4.8.5/mpi/lib
		NO_DEFAULT_PATH
	)

ELSE()
	FIND_PATH(HDF5_INCLUDE_PATH
		NAMES hdf5.h
		PATHS /usr/include/hdf5/openmpi
		NO_DEFAULT_PATH
		)

	FIND_LIBRARY(HDF5_LIBRARY
		NAMES hdf5
		PATHS /usr/lib/x86_64-linux-gnu/hdf5/openmpi
		NO_DEFAULT_PATH
		)
ENDIF()

IF(HDF5_LIBRARY)
	SET(HDF5_LIBRARIES ${HDF5_LIBRARY})
ENDIF()



IF(HDF5_INCLUDE_PATH)
	MESSAGE(STATUS "Found parallel Hdf5 header: ${HDF5_INCLUDE_PATH}/hdf5.h")
ELSE()
	MESSAGE(FATAL_ERROR "Could not find parallel Hdf5 header")
ENDIF()

IF(HDF5_LIBRARIES)
	MESSAGE(STATUS "Found parallel Hdf5 library: ${HDF5_LIBRARIES}")
ELSE()
	MESSAGE(FATAL_ERROR "Could not find parallel Hdf5 library")
ENDIF()
