IF (${NAMEHOST} MATCHES ${NAMEHOST_ZEUS})
	FIND_PATH(MATH_INCLUDE_PATH
		NAMES math.h
		PATHS /usr/include
		NO_DEFAULT_PATH
	)

	FIND_LIBRARY(MATH_LIBRARY
		NAMES m
		PATHS /usr/lib64
		NO_DEFAULT_PATH
	)
ELSE()
	FIND_PATH(MATH_INCLUDE_PATH
		NAMES math.h
		PATHS /usr/include
		NO_DEFAULT_PATH
		)

	FIND_LIBRARY(MATH_LIBRARY
		NAMES m
		PATHS /usr/lib/x86_64-linux-gnu
		NO_DEFAULT_PATH
		)
ENDIF()

IF(MATH_LIBRARY)
	SET(MATH_LIBRARIES ${MATH_LIBRARY})
ENDIF()

IF(MATH_INCLUDE_PATH)
	MESSAGE(STATUS "Found math header: ${MATH_INCLUDE_PATH}/math.h")
ELSE()
	MESSAGE(FATAL_ERROR "Could not find math header")
ENDIF()

IF(MATH_LIBRARIES)
	MESSAGE(STATUS "Found math library: ${MATH_LIBRARIES}")
ELSE()
	MESSAGE(FATAL_ERROR "Could not find math library")
ENDIF()
