IF (${NAMEHOST} MATCHES ${NAMEHOST_ZEUS})
	FIND_PATH(PTHREAD_INCLUDE_PATH
		NAMES pthread.h
		PATHS /usr/include
		NO_DEFAULT_PATH
	)

	FIND_LIBRARY(PTHREAD_LIBRARY
		NAMES pthread
		PATHS /usr/lib64
		NO_DEFAULT_PATH
	)
ELSE()
	FIND_PATH(PTHREAD_INCLUDE_PATH
		NAMES pthread.h
		PATHS /usr/include
		NO_DEFAULT_PATH
		)

	FIND_LIBRARY(PTHREAD_LIBRARY
		NAMES pthread
		PATHS /usr/lib/x86_64-linux-gnu
		NO_DEFAULT_PATH
		)
ENDIF()

IF(PTHREAD_LIBRARY)
	SET(PTHREAD_LIBRARIES ${PTHREAD_LIBRARY})
ENDIF()

IF(PTHREAD_INCLUDE_PATH)
	MESSAGE(STATUS "Found pthread header: ${PTHREAD_INCLUDE_PATH}/pthread.h")
ELSE()
	MESSAGE(FATAL_ERROR "Could not find pthread header")
ENDIF()

IF(PTHREAD_LIBRARIES)
	MESSAGE(STATUS "Found pthread library: ${PTHREAD_LIBRARIES}")
ELSE()
	MESSAGE(FATAL_ERROR "Could not find pthread library")
ENDIF()
