#!/usr/bin/env python
# -*- coding: utf-8 -*-

from visualization import *



def get_text_label(key, entry):
	if (key == "time_method"):
		thetext = entry
		thelabel = entry
	elif (key == "L"):
		thetext = "L"+str(entry)
		thelabel = "L = "+str(entry)
	elif (key == "cutoff"):
		thetext = "cutoff"+str(entry)+"S"
		thelabel = "R = "+str(entry)+"S"
	elif (key == "rescale"):
		if (entry):
			thetext = "rescale"
			thelabel = "with rescaling"
		else:
			thetext = "norescale"
			thelabel = "without rescaling"
	elif (key == "residual"):
		if (entry):
			thetext = "residual"
			thelabel = "with residual method"
		else:
			thetext = "noresidual"
			thelabel = "without residual method"
	elif (key == "N"):
		thetext = "N"+str(entry)
		thelabel = str(entry)+"x"+str(entry)

	return [thetext, thelabel]


def get_namesubdir(dic_out, dic_in, struct_namedir):
	subdir = ""
	i = 0
	for key in struct_namedir:
		for key_in in dic_in.keys():
			if (key_in == key):
				# Found the key in dic_in
				[thetext, thelabel] = get_text_label(key, dic_in[key])
				subdir += thetext
		for key_out in dic_out.keys():
			if (key_out == key):
				# Found the key in dic_out
				[thetext, thelabel] = get_text_label(key, dic_out[key])
				subdir += thetext
		i += 1
		if (i < len(struct_namedir)-1):
			subdir += "_"

	return subdir







def visu_BKW(rootdir, prefix, struct_namedir, list_dics_outplot, dic_lists_inplot, list_N):

	list_linecolors = ["blue", "green", "red", "magenta", "cyan", "yellow", "black"]
	list_linestyles = ["solid", "dashed", "dashdot", "dashdotdotted"]
	list_markers = ["P", "X", "*", "o", "v", "s"]

	xlabel = "N"
	ylabel = "Linf-L2 error"
	typediag = "LinfL2error"
	diag_file = prefix+"_"+typediag+".txt"
	

	mintab = []
	maxtab = []
	lmax = 0
	ylim = ""

	for isave in range(2):
		for i_out in range(len(list_dics_outplot)):
			dic_out = list_dics_outplot[i_out]

			# We are able to get the title of the output plot, the name of the produced png
			title = ylabel+" ("
			outputpng = rootdir+"/"+typediag+"_"
			i_key = 0
			for key in dic_out.keys():
				entry = dic_out[key]
				[thetext, thelabel] = get_text_label(key, entry)
				title += thelabel
				outputpng += thetext
				if (i_key < len(dic_out.keys())-1):
					title += ", "
					outputpng += "_"
				else:
					title += ")"
					outputpng += ".png"
				i_key += 1

			keys_in = list(dic_lists_inplot.keys())
			key_in_0 = keys_in[0]
			i_0 = 0
			dic_in = {}
			x_list = []
			y_list = []
			linestyles = []
			linecolors = []
			markers = []
			labels = []
			for val_in_0 in dic_lists_inplot[key_in_0]:
				dic_in[key_in_0] = val_in_0
				thelinecolor = list_linecolors[i_0]

				[text_0, label_0] = get_text_label(key_in_0, val_in_0)

				if (len(keys_in) > 1):
					key_in_1 = keys_in[1]
					i_1 = 0
					for val_in_1 in dic_lists_inplot[key_in_1]:
						dic_in[key_in_1] = val_in_1
						themarker = list_markers[i_1]

						[text_1, label_1] = get_text_label(key_in_1, val_in_1)

						if (len(keys_in) > 2):
							key_in_2 = key_in[2]
							i_2 = 0
							for val_in_2 in dic_lists_inplot[key_in_2]:
								dic_in[key_in_2] = val_in_2
								thelinestyle = list_linestyles[i_2]

								[text_2, label_2] = get_text_label(key_in_2, val_in_2)

								rootsubdir = get_namesubdir(dic_out, dic_in, struct_namedir)
								rootsubdir = rootdir+"/"+rootsubdir

								if (len(keys_in) > 3):
									print("Error: cannot handle more than 3 categories of curves on a same plot")
									exit()

								thelabel = label_0+", "+label_1+", "+label_2
								lmax = max([lmax, len(thelabel)])


								LinfL2_list = []
								for N in list_N:
									textN = "N"+str(N)
							
									subdir = rootdir+"/"+rootsubdir+"_"+textN
									namefile = subdir+"/"+diag_file
									f = open(namefile, "r")
									lines = f.readlines()
									LinfL2 = float(lines[-1].split(" ")[-1])
									LinfL2_list.append(LinfL2)
									f.close()

								x_list.append(list_N)
								y_list.append(LinfL2_list)
								labels.append(thelabel)

								markers.append(themarker)
								linestyles.append(thelinestyle)
								linecolors.append(thelinecolor)

								i_2 += 1
						else:
							rootsubdir = get_namesubdir(dic_out, dic_in, struct_namedir)

							thelabel = label_0+", "+label_1
							lmax = max([lmax, len(thelabel)])

							LinfL2_list = []
							for N in list_N:
								textN = "N"+str(N)
							
								subdir = rootdir+"/"+rootsubdir+"_"+textN
								namefile = subdir+"/"+diag_file
								f = open(namefile, "r")
								lines = f.readlines()
								LinfL2 = float(lines[-1].split(" ")[-1])
								LinfL2_list.append(LinfL2)
								f.close()

							x_list.append(list_N)
							y_list.append(LinfL2_list)
							labels.append(thelabel)
				
							markers.append(themarker)
							linecolors.append(thelinecolor)

						i_1 += 1
				else:
					rootsubdir = get_namesubdir(dic_out, dic_in, struct_namedir)

					thelabel = label_0
					lmax = max([lmax, len(thelabel)])


					LinfL2_list = []
					for N in list_N:
						textN = "N"+str(N)
							
						subdir = rootdir+"/"+rootsubdir+"_"+textN
						namefile = subdir+"/"+diag_file
						f = open(namefile, "r")
						lines = f.readlines()
						LinfL2 = float(lines[-1].split(" ")[-1])
						LinfL2_list.append(LinfL2)
						f.close()

					x_list.append(list_N)
					y_list.append(LinfL2_list)
					labels.append(thelabel)

					linecolors.append(thelinecolor)

				i_0 += 1

			# At this point, we have loaded the data corresponding to the full set of curves to be plotted
			if (len(keys_in) <= 2):
				linestyles = ""
			if (len(keys_in) == 1):
				markers = ""
			[theminval, themaxval] = plot_curves(x_list, y_list, xlabel, ylabel, title, outputpng, labels=labels, markers=markers, linecolors=linecolors, linestyles=linestyles, yscale="log", ylim=ylim)
			mintab.append(theminval)
			maxtab.append(themaxval)
		ylim = [min(mintab), max(maxtab)]








rootdir = "./results/BKW"
prefix = "diags"
struct_namedir = ["time_method", "cutoff", "L", "rescale", "residual", "N"]

list_N = [16, 32, 64, 128]
list_time_method = ["Euler", "RK2"]
list_L = [3., 6.]
list_cutoff = [1.,2.]
list_rescale = [True, False]
list_residual = [True, False]

# List of the parameters of which we want to compare the impact on a same graph
dic_lists_inplot = {}
dic_lists_inplot["L"] = list_L
dic_lists_inplot["rescale"] = list_rescale

# List of the other parameters
list_dics_outplot = []
for time_method in list_time_method:
	for cutoff in list_cutoff:
		for residual in list_residual:
			dic = {}
			dic["cutoff"] = cutoff
			dic["residual"] = residual
			dic["time_method"] = time_method
			list_dics_outplot.append(dic)

visu_BKW(rootdir, prefix, struct_namedir, list_dics_outplot, dic_lists_inplot, list_N)




# List of the parameters of which we want to compare the impact on a same graph
dic_lists_inplot = {}
dic_lists_inplot["L"] = list_L
dic_lists_inplot["cutoff"] = list_cutoff

# List of the other parameters
list_dics_outplot = []
for time_method in list_time_method:
	for rescale in list_rescale:
		for residual in list_residual:
			dic = {}
			dic["rescale"] = rescale
			dic["residual"] = residual
			dic["time_method"] = time_method
			list_dics_outplot.append(dic)

visu_BKW(rootdir, prefix, struct_namedir, list_dics_outplot, dic_lists_inplot, list_N)






