#include "allocation.h"


char* allocation_1d_char(int n){
	extern int nb_alloc_1d_char;
	
	char *c;
	
	c = malloc(sizeof(char)*n);
	nb_alloc_1d_char++;
	
	return c;
}


void free_1d_char(char *c){
	extern int nb_alloc_1d_char;
	
	free(c);
	nb_alloc_1d_char--;
}


int* allocation_1d_int(int n){
	extern int nb_alloc_1d_int;
	
	int *N;
	
	N = malloc(sizeof(int)*n);
	nb_alloc_1d_int++;
	
	return N;
}


void free_1d_int(int *N){
	extern int nb_alloc_1d_int;
	
	free(N);
	nb_alloc_1d_int--;
}



double* allocation_1d(int n){
	extern int nb_alloc_1d;

	double *f;
	
	f = malloc(sizeof(double)*n);
	nb_alloc_1d++;
	
	return f;
}


void free_1d(double *f){
	extern int nb_alloc_1d;
	
	free(f);
	nb_alloc_1d--;
}


double** allocation_2d(int nx, int ny){
	extern int nb_alloc_2d;

	double** f;
	
	f = malloc(nx * sizeof(double*));
	f[0] = malloc(nx*ny*sizeof(double));
	for (int i = 1; i < nx; i++)
		f[i] = f[0] + i*ny;
	nb_alloc_2d++;
	
	return f;
}


void free_2d(double** f){
	extern int nb_alloc_2d;
	
	free(f[0]);
	free(f);
	
	nb_alloc_2d--;
}


double*** allocation_3d(int nx, int ny, int nz){
	extern int nb_alloc_3d;
	
	double*** f;
	
	f = malloc(nx * sizeof(double**));
	f[0] = malloc(nx*ny * sizeof(double*));
	f[0][0] = malloc(nx*ny*nz * sizeof(double));
	for (int i = 1; i < nx; i++)
		f[i] = f[0] + i*ny;
	for (int i = 0; i < nx; i++){
		for (int j = 0; j < ny; j++){
			if ((i != 0) || (j != 0))
				f[i][j] = f[0][0] + nz*(j+i*ny);
		}
	}
	nb_alloc_3d++;
	
	return f;
}


void free_3d(double*** f){
	extern int nb_alloc_3d;
	
	free(f[0][0]);
	free(f[0]);
	free(f);
	
	nb_alloc_3d--;
}
