#include "./src/base/defs.h"




void free_diags(DIAGS mydiags, PARAMETERS parameters){
	free_1d(mydiags.u_av);
	if (!parameters.condensation)
		free_1d(mydiags.u_av_limit);
	free_2d(mydiags.stress_energy);
	switch (parameters.ndim){
		case DIM2:
			free_2d(mydiags.Gloc_2d);
			if (!(parameters.condensation))
				free_2d(mydiags.Gloclimit_2d);
			if (parameters.exact_solution)
				free_2d(mydiags.Glocexact_2d);
			break;
		
		case DIM3:
			free_3d(mydiags.Gloc_3d);
			if (!(parameters.condensation))
				free_3d(mydiags.Gloclimit_3d);
			if (parameters.exact_solution)
				free_3d(mydiags.Glocexact_3d);
			break;

		default:
			error("Unknown dimensionality");
	}
}


void free_parameters(PARAMETERS parameters){
	free_1d(parameters.u0);
	if (parameters.type_f0 == CLASSICAL_BIMAXWELLIAN){
		free_1d(parameters.u1);
		free_1d(parameters.u2);
	}
	if (parameters.type_f0 == CLASSICAL_MULTIMAXWELLIAN)
		free_2d(parameters.u);

	free_1d_int(parameters.ivx0tab);
	free_1d_int(parameters.ivy0tab);
	free_1d_int(parameters.ivz0tab);
	free_1d_int(parameters.nvxtab);
	free_1d_int(parameters.nvytab);
	free_1d_int(parameters.nvztab);

#ifdef key_force_vectorize
	free_1d_int(parameters.kvxabstab);
	free_1d_int(parameters.kvyabstab);
	free_1d_int(parameters.kvzabstab);
#endif
}
