#ifndef COLLISION_H
#define COLLISION_H

#include "defs.h"
#include "sphere_lebedev_rule.h"
//#include "allocation.h"

#if defined(key_fftw_mpi) || defined(key_fftw_openmp) || defined(key_fftw)
void collision_Q1c_fftw(fftw_complex *, fftw_complex *, double **, double **, PARAMETERS);
//void collision_Q1c_convolution_fftw(fftw_complex *, fftw_complex *, double ***, double ***, double *, PARAMETERS);


void collision_Q2c_fftw(fftw_complex *, fftw_complex *, fftw_complex *, double **, double **, PARAMETERS);
//void collision_Q2c_convolution_fftw(fftw_complex *, fftw_complex *, fftw_complex *, double ***, double *, PARAMETERS);


void collision_Q1q_fftw(fftw_complex *, fftw_complex *, double **, double **, PARAMETERS);
//void collision_Q1q_convolution_fftw(fftw_complex *, fftw_complex *, double ***, double ***, double ***, double *, PARAMETERS);


void collision_Q2q_fftw(fftw_complex *, fftw_complex *, fftw_complex *, double **, double **, PARAMETERS);
//void collision_Q2q_convolution_fftw(fftw_complex *, fftw_complex *, fftw_complex *, double ***, double ***, double *, PARAMETERS);


void collision_Q3q_fftw(fftw_complex *, fftw_complex *, fftw_complex *, double **, double **, PARAMETERS);
//void collision_Q3q_convolution_fftw(fftw_complex *, fftw_complex *, fftw_complex *, double ***, double ***, double *, PARAMETERS);


void collision_Q4q_fftw(fftw_complex *, fftw_complex *, fftw_complex *, double **, double **, PARAMETERS);
//void collision_Q4q_convolution_fftw(fftw_complex *, fftw_complex *, fftw_complex *, double ***, double ***, double *, PARAMETERS);


void collision_Qtotal_fftw(double *, double *, double **, double **, double, PARAMETERS);
//void collision_Qtotal_quick_convolution_fftw(double *, double *, double ***, double ***, double ***, double *, double, PARAMETERS);
void collision_Qtotal_quick_convolution_fftw(double *, double *, double **, double **, double *, double, PARAMETERS);
//void collision_Qtotal_force_convolution_fftw(double *, double *, double ***, double ***, double ***, double *, double, PARAMETERS);


void free_crossmode(PARAMETERS);
#endif


#endif
