#ifndef CUDA_COLLISION_CUH
#define CUDA_COLLISION_CUH

#include "defs.h"

#ifdef key_cufft

// Kernel functions
__global__ void compute_product_alphareal_Gcomplex(double *, cufftDoubleComplex *, cufftDoubleComplex *, int);
__global__ void compute_product_alphareal_betacomplex(cufftDoubleComplex *, cufftDoubleComplex *, cufftDoubleComplex *, int);
__global__ void compute_product_alphareal_Gcomplexconj(double *d_alphareal, cufftDoubleComplex *, cufftDoubleComplex *, int);
__global__ void update_with_product_C_alphareal_betareal(cufftDoubleComplex *, cufftDoubleComplex *, cufftDoubleComplex *, double, int);
__global__ void update_with_product_C_alphareal_betareal_gammareal(cufftDoubleComplex *, cufftDoubleComplex *, cufftDoubleComplex *, cufftDoubleComplex *, double, int);
__global__ void update_with_product_C_alphareal_betacomplex_gammacomplex_deltacomplex(cufftDoubleComplex *, cufftDoubleComplex *, cufftDoubleComplex *, cufftDoubleComplex *, cufftDoubleComplex *, double, int, int);
__global__ void compute_product_alphareal_alphaprimereal_Gcomplex(double *, double *, cufftDoubleComplex *, cufftDoubleComplex *, int);
__global__ void kill_imaginary_part(cufftDoubleComplex *, int);
__global__ void kill_real_part(cufftDoubleComplex *, int);
__global__ void normalize(cufftDoubleComplex *, int);
__global__ void compute_crossmodes_p2pi(cufftDoubleComplex *, int *, int *, int);
__global__ void add_real_part(cufftDoubleComplex *, cufftDoubleComplex *, double, int);

__global__ void compute_ABCGhat_spectral(cufftDoubleComplex *, cufftDoubleComplex *, cufftDoubleComplex *, cufftDoubleComplex *, double *, double *, double, int *, int);
__global__ void update_Qtotal_quick_convolution(cufftDoubleComplex *, cufftDoubleComplex *, cufftDoubleComplex *, cufftDoubleComplex *, double *, double, double, int);
__global__ void set_to_zero(double *, int);


// Functions to be run from CPU
void compute_Q1c_cufft(cufftDoubleComplex *, cufftDoubleComplex *, double **, double **, int, int *, int);
void compute_Q2c_cufft(cufftDoubleComplex *, cufftDoubleComplex *, cufftDoubleComplex *, double **, double **, int, int *, int);
void compute_Q1q_cufft(cufftDoubleComplex *, cufftDoubleComplex *, double **, double **, int, int *, int);
void compute_Q2q_cufft(cufftDoubleComplex *, cufftDoubleComplex *, cufftDoubleComplex *, double **, double **, int, int *, int);
void compute_Q3q_cufft(cufftDoubleComplex *, cufftDoubleComplex *, cufftDoubleComplex *, double **, double **, int, int *, int);
void compute_Q4q_cufft(cufftDoubleComplex *, cufftDoubleComplex *, cufftDoubleComplex *, double **, double **, int, int *, int);
//void collision_Qtotal_cufft(double *, double *, double **, double **, double, PARAMETERS);

//void collision_Qtotal_quick_convolution_cufft(double *, double *, double **, double **, double *, double, PARAMETERS);


#endif

#endif
