#include "test_quadrature.h"

int crossmode_done;
double ***crossmode_cos, ***crossmode_sin;

int nb_alloc_1d, nb_alloc_2d, nb_alloc_3d;
int nb_alloc_1d_char;
int nb_alloc_1d_int;



int main(int argc, char **argv){
    double R = 10.;
    double res, exactval;
    double pi = 4.*atan(1.);

    int P1max = 10;
    int P2max = 3;
    int P3max = 3;


    nb_alloc_1d = 0;
	nb_alloc_2d = 0;
	nb_alloc_3d = 0;
	nb_alloc_1d_char = 0;
	nb_alloc_1d_int = 0;

    exactval = 4.*pi*pow(R,3)/3. * 4.*pi;

    for (int P1 = 1; P1 <= P1max; P1++){
        for (int P2 = 1; P2 <= P2max; P2++){
            for (int P3 = 1; P3 <= P3max; P3++){
                res = integrate_Gamba_3d(R, P1, P2, P3);
                printf("P1 = %d, P2 = %d, P3 = %d | res = %.15e", P1, P2, P3, res);
                printf(" | exact = %.15e | ratio = %.15e", exactval, res/exactval);
                printf("\n");
            }
        }
    }



    exit(EXIT_SUCCESS);
}